<< problem 95 - Amicable chains | Large non-Mersenne prime - problem 97 >> |
Problem 96: Su Doku
(see projecteuler.net/problem=96)
Su Doku (Japanese meaning number place) is the name given to a popular puzzle concept.
Its origin is unclear, but credit must be attributed to Leonhard Euler who invented a similar, and much more difficult, puzzle idea called Latin Squares.
The objective of Su Doku puzzles, however, is to replace the blanks (or zeros) in a 9 by 9 grid in such that each row, column, and 3 by 3 box contains each of the digits 1 to 9.
Below is an example of a typical starting puzzle grid and its solution grid.
003020600
900305001
001806400
008102900
700000008
006708200
002609500
800203009
005010300
483921657
967345821
251876493
548132976
729564138
136798245
372689514
814253769
695417382
A well constructed Su Doku puzzle has a unique solution and can be solved by logic, although it may be necessary
to employ "guess and test" methods in order to eliminate options (there is much contested opinion over this).
The complexity of the search determines the difficulty of the puzzle; the example above is considered easy because it can be solved by straight forward direct deduction.
The 6K text file, sudoku.txt (right click and 'Save Link/Target As...'), contains fifty different Su Doku puzzles ranging in difficulty,
but all with unique solutions (the first puzzle in the file is the example above).
By solving all fifty puzzles find the sum of the 3-digit numbers found in the top left corner of each solution grid;
for example, 483 is the 3-digit number found in the top left corner of the solution grid above.
My Algorithm
My program uses backtracking to solve
a Su Doku: it looks for the first empty cell (which contains a zero).
Then it scans the row, column and the cell's 3x3 box to figure out which numbers could be placed in the cell (see available
).
The algorithm tries all available
numbers and recursively calls itself.
If no number can be placed in the current empty cell, then the algorithm failed and has to backtrack to the previous cell (return false
).
If no empty cell can be found, then the Su Doku was solved (return true
).
To speed up the program, the board is modified in-place.
Modifications by HackerRank
Just show the full solution of the current board.
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This live test is based on the Hackerrank problem.
This is equivalent toecho "003020600 900305001 001806400 008102900 700000008 006708200 002609500 800203009 005010300" | ./96
Output:
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, as well as the input data, too.
The code contains #ifdef
s to switch between the original problem and the Hackerrank version.
Enable #ifdef ORIGINAL
to produce the result for the original problem (default setting for most problems).
#include <string>
#include <iostream>
typedef unsigned int Board[9][9];
const unsigned int Empty = 0;
// find the first solution and store it in board
bool solve(Board& board)
{
for (unsigned int y = 0; y < 9; y++)
for (unsigned int x = 0; x < 9; x++)
{
// already solved cell ?
if (board[x][y] != Empty)
continue;
// track which numbers could be placed in the current cell
bool available[9+1] = { false, true, true, true, true, true, true, true, true, true };
// note: available[0] is a dummy entry, the program only uses available[1..9]
// same row and column
for (unsigned int i = 0; i < 9; i++)
{
if (board[i][y] != Empty)
available[board[i][y]] = false;
if (board[x][i] != Empty)
available[board[x][i]] = false;
}
// same region (3x3 area)
unsigned int rx = (x / 3) * 3;
unsigned int ry = (y / 3) * 3;
for (unsigned int i = 0; i < 3; i++)
for (unsigned int j = 0; j < 3; j++)
if (board[i + rx][j + ry] != Empty)
available[board[i + rx][j + ry]] = false;
// try all still available numbers
for (unsigned int i = 1; i <= 9; i++)
if (available[i])
{
board[x][y] = i;
if (solve(board))
return true;
}
// all failed, restore old board
board[x][y] = Empty;
return false;
}
// solved it
return true;
}
int main()
{
//#define ORIGINAL
#ifdef ORIGINAL
unsigned int tests = 50;
unsigned int sum = 0;
#else
unsigned int tests = 1;
#endif
while (tests--)
{
#ifdef ORIGINAL
// skip labels "GRID xy"
std::string dummy;
std::cin >> dummy >> dummy;
#endif
// read board
Board board;
for (unsigned int y = 0; y < 9; y++)
{
std::string line;
std::cin >> line;
for (unsigned int x = 0; x < 9; x++)
board[x][y] = line[x] - '0';
}
// and replace all zeros (=Empty) with proper digits
solve(board);
#ifdef ORIGINAL
// the first the cells
sum += 100 * board[0][0] + 10 * board[1][0] + board[2][0];
#else
// print full solution
for (unsigned int y = 0; y < 9; y++)
{
for (unsigned int x = 0; x < 9; x++)
std::cout << board[x][y];
std::cout << std::endl;
}
#endif
}
#ifdef ORIGINAL
std::cout << sum;
#endif
return 0;
}
This solution contains 13 empty lines, 15 comments and 12 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 0.07 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
March 13, 2017 submitted solution
May 6, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler096
My code solves 21 out of 21 test cases (score: 100%)
Difficulty
Project Euler ranks this problem at 25% (out of 100%).
Hackerrank describes this problem as hard.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Links
projecteuler.net/thread=96 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
C# www.mathblog.dk/project-euler-96-su-doku/ (written by Kristian Edlund)
Python github.com/hughdbrown/Project-Euler/blob/master/euler-096.py (written by Hugh Brown)
Python github.com/nayuki/Project-Euler-solutions/blob/master/python/p096.py (written by Nayuki)
Python github.com/smacke/project-euler/blob/master/python/96.py (written by Stephen Macke)
Python github.com/steve98654/ProjectEuler/blob/master/096.py
C++ github.com/HaochenLiu/My-Project-Euler/blob/master/096.cpp (written by Haochen Liu)
C++ github.com/Meng-Gen/ProjectEuler/blob/master/96.cc (written by Meng-Gen Tsai)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p096.java (written by Nayuki)
Go github.com/frrad/project-euler/blob/master/golang/Problem096.go (written by Frederick Robinson)
Clojure github.com/rm-hull/project-euler/blob/master/src/euler096.clj (written by Richard Hull)
Scala github.com/samskivert/euler-scala/blob/master/Euler096.scala (written by Michael Bayne)
Perl github.com/gustafe/projecteuler/blob/master/096-Su-Doku.pl (written by Gustaf Erikson)
Rust github.com/gifnksm/ProjectEulerRust/blob/master/src/bin/p096.rs
Sage github.com/roosephu/project-euler/blob/master/96.sage (written by Yuping Luo)
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 95 - Amicable chains | Large non-Mersenne prime - problem 97 >> |